/* Generated by re2c 0.13.5 */
#line 1 "mwlib/_mwscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2009 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_singlequote,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 132 "mwlib/_mwscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 168 "mwlib/_mwscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 148 "mwlib/_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if (yych <= '-') {
		if (yych <= '"') {
			if (yych <= 0x001F) goto yy18;
			if (yych <= ' ') goto yy2;
			if (yych <= '!') goto yy10;
			goto yy18;
		} else {
			if (yych <= ')') {
				if (yych <= '#') goto yy13;
				goto yy18;
			} else {
				if (yych <= '*') goto yy13;
				if (yych <= ',') goto yy18;
				goto yy17;
			}
		}
	} else {
		if (yych <= '<') {
			if (yych <= '9') goto yy18;
			if (yych <= ':') goto yy4;
			if (yych <= ';') goto yy15;
			goto yy18;
		} else {
			if (yych <= 'z') {
				if (yych <= '=') goto yy11;
				goto yy18;
			} else {
				if (yych <= '{') goto yy6;
				if (yych <= '|') goto yy8;
				goto yy18;
			}
		}
	}
yy2:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy3;
		if (yych <= '!') goto yy48;
	} else {
		if (yych <= ':') goto yy48;
		if (yych <= 'z') goto yy3;
		if (yych <= '|') goto yy48;
	}
yy3:
#line 212 "mwlib/_mwscan.re"
	{RET(t_pre);}
#line 201 "mwlib/_mwscan.cc"
yy4:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '*') {
		if (yych == '#') goto yy27;
		if (yych >= '*') goto yy27;
	} else {
		if (yych <= ':') {
			if (yych >= ':') goto yy43;
		} else {
			if (yych == '{') goto yy45;
		}
	}
yy5:
#line 218 "mwlib/_mwscan.re"
	{RET(t_colon);}
#line 218 "mwlib/_mwscan.cc"
yy6:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '|') goto yy41;
yy7:
#line 222 "mwlib/_mwscan.re"
	{goto not_bol;}
#line 225 "mwlib/_mwscan.cc"
yy8:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ',') {
		if (yych == '+') goto yy33;
	} else {
		if (yych <= '-') goto yy36;
		if (yych == '}') goto yy39;
	}
yy9:
#line 188 "mwlib/_mwscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 248 "mwlib/_mwscan.cc"
yy10:
	yych = *++YYCURSOR;
	goto yy9;
yy11:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy31;
	goto yy30;
yy12:
#line 213 "mwlib/_mwscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 262 "mwlib/_mwscan.cc"
yy13:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy28;
yy14:
#line 217 "mwlib/_mwscan.re"
	{RET(t_item);}
#line 270 "mwlib/_mwscan.cc"
yy15:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy26;
yy16:
#line 219 "mwlib/_mwscan.re"
	{RET(t_semicolon);}
#line 278 "mwlib/_mwscan.cc"
yy17:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '-') goto yy19;
	goto yy7;
yy18:
	yych = *++YYCURSOR;
	goto yy7;
yy19:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy21;
yy20:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy5;
		}
	} else {
		goto yy7;
	}
yy21:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy20;
yy22:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy22;
#line 220 "mwlib/_mwscan.re"
	{RET(t_hrule);}
#line 310 "mwlib/_mwscan.cc"
yy25:
	++YYCURSOR;
	yych = *YYCURSOR;
yy26:
	if (yych == ';') goto yy25;
	goto yy16;
yy27:
	++YYCURSOR;
	yych = *YYCURSOR;
yy28:
	if (yych == '#') goto yy27;
	if (yych == '*') goto yy27;
	goto yy14;
yy29:
	++YYCURSOR;
	yych = *YYCURSOR;
yy30:
	if (yych == '\t') goto yy29;
	if (yych == ' ') goto yy29;
	goto yy12;
yy31:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy29;
		goto yy12;
	} else {
		if (yych <= ' ') goto yy29;
		if (yych == '=') goto yy31;
		goto yy12;
	}
yy33:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '+') goto yy33;
#line 202 "mwlib/_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 356 "mwlib/_mwscan.cc"
yy36:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy36;
#line 177 "mwlib/_mwscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 371 "mwlib/_mwscan.cc"
yy39:
	++YYCURSOR;
#line 174 "mwlib/_mwscan.re"
	{--tablemode; RET(t_end_table);}
#line 376 "mwlib/_mwscan.cc"
yy41:
	++YYCURSOR;
#line 173 "mwlib/_mwscan.re"
	{++tablemode; RET(t_begin_table);}
#line 381 "mwlib/_mwscan.cc"
yy43:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '*') {
		if (yych == '#') goto yy27;
		if (yych <= ')') goto yy5;
		goto yy27;
	} else {
		if (yych <= ':') {
			if (yych <= '9') goto yy5;
			goto yy43;
		} else {
			if (yych != '{') goto yy5;
		}
	}
yy45:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy41;
	goto yy20;
yy46:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy33;
		goto yy9;
	} else {
		if (yych <= '-') goto yy36;
		if (yych == '}') goto yy39;
		goto yy9;
	}
yy47:
	++YYCURSOR;
	yych = *YYCURSOR;
yy48:
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy20;
		if (yych <= ' ') goto yy47;
		if (yych >= '"') goto yy20;
	} else {
		if (yych <= 'z') {
			if (yych <= ':') goto yy50;
			goto yy20;
		} else {
			if (yych <= '{') goto yy45;
			if (yych <= '|') goto yy46;
			goto yy20;
		}
	}
	yych = *++YYCURSOR;
	goto yy9;
yy50:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == ':') goto yy50;
	if (yych == '{') goto yy45;
	goto yy20;
}
#line 223 "mwlib/_mwscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 448 "mwlib/_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\'') {
			if (yych <= ' ') {
				if (yych <= 0x0000) goto yy74;
				if (yych == '\n') goto yy65;
				goto yy76;
			} else {
				if (yych <= '!') goto yy68;
				if (yych <= '%') goto yy76;
				if (yych <= '&') goto yy73;
				goto yy71;
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy76;
				if (yych <= '9') goto yy61;
				if (yych <= ':') goto yy70;
				goto yy76;
			} else {
				if (yych <= '<') goto yy72;
				if (yych <= '=') goto yy63;
				if (yych <= '@') goto yy76;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '^') {
				if (yych <= '[') goto yy54;
				if (yych == ']') goto yy62;
				goto yy76;
			} else {
				if (yych <= '_') goto yy60;
				if (yych <= '`') goto yy76;
				if (yych <= 'e') goto yy61;
				goto yy58;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'h') goto yy59;
				if (yych <= 'l') goto yy61;
				goto yy56;
			} else {
				if (yych <= 'z') goto yy61;
				if (yych == '|') goto yy67;
				goto yy76;
			}
		}
	}
yy54:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '[':	goto yy286;
	case 'f':	goto yy289;
	case 'h':	goto yy288;
	case 'm':	goto yy290;
	default:	goto yy55;
	}
yy55:
#line 272 "mwlib/_mwscan.re"
	{RET(t_special);}
#line 515 "mwlib/_mwscan.cc"
yy56:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 'a') goto yy274;
	goto yy121;
yy57:
#line 238 "mwlib/_mwscan.re"
	{RET(t_text);}
#line 523 "mwlib/_mwscan.cc"
yy58:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy266;
	goto yy121;
yy59:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy256;
	goto yy121;
yy60:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy122;
	goto yy121;
yy61:
	yych = *++YYCURSOR;
	goto yy121;
yy62:
	yych = *++YYCURSOR;
	if (yych == ']') goto yy118;
	goto yy55;
yy63:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy116;
	goto yy115;
yy64:
#line 241 "mwlib/_mwscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 561 "mwlib/_mwscan.cc"
yy65:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\n') goto yy111;
#line 254 "mwlib/_mwscan.re"
	{newline(); RET(t_newline);}
#line 567 "mwlib/_mwscan.cc"
yy67:
	yych = *++YYCURSOR;
	if (yych <= '*') {
		if (yych == '!') goto yy107;
		goto yy55;
	} else {
		if (yych <= '+') goto yy109;
		if (yych == '|') goto yy107;
		goto yy55;
	}
yy68:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '!') goto yy107;
yy69:
#line 282 "mwlib/_mwscan.re"
	{RET(t_text);}
#line 584 "mwlib/_mwscan.cc"
yy70:
	yych = *++YYCURSOR;
	goto yy55;
yy71:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy104;
	goto yy69;
yy72:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych == '!') goto yy88;
		if (yych <= '.') goto yy69;
		goto yy89;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy69;
			goto yy90;
		} else {
			if (yych <= '`') goto yy69;
			if (yych <= 'z') goto yy90;
			goto yy69;
		}
	}
yy73:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych == '#') goto yy77;
		if (yych <= '/') goto yy69;
		goto yy79;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy69;
			goto yy79;
		} else {
			if (yych <= '`') goto yy69;
			if (yych <= 'z') goto yy79;
			goto yy69;
		}
	}
yy74:
	++YYCURSOR;
#line 281 "mwlib/_mwscan.re"
	{newline(); return t_end;}
#line 630 "mwlib/_mwscan.cc"
yy76:
	yych = *++YYCURSOR;
	goto yy69;
yy77:
	yych = *++YYCURSOR;
	if (yych <= 'W') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy84;
	} else {
		if (yych <= 'X') goto yy83;
		if (yych == 'x') goto yy83;
	}
yy78:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy55;
		} else {
			goto yy69;
		}
	} else {
		goto yy57;
	}
yy79:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy79;
		if (yych <= ':') goto yy78;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy78;
			goto yy79;
		} else {
			if (yych <= '`') goto yy78;
			if (yych <= 'z') goto yy79;
			goto yy78;
		}
	}
yy81:
	++YYCURSOR;
#line 279 "mwlib/_mwscan.re"
	{RET(t_entity);}
#line 675 "mwlib/_mwscan.cc"
yy83:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy78;
	goto yy87;
yy84:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '/') goto yy78;
	if (yych <= '9') goto yy84;
	if (yych == ';') goto yy81;
	goto yy78;
yy86:
	++YYCURSOR;
	yych = *YYCURSOR;
yy87:
	if (yych <= ';') {
		if (yych <= '/') goto yy78;
		if (yych <= '9') goto yy86;
		if (yych <= ':') goto yy78;
		goto yy81;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy78;
			goto yy86;
		} else {
			if (yych <= '`') goto yy78;
			if (yych <= 'f') goto yy86;
			goto yy78;
		}
	}
yy88:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy96;
	goto yy78;
yy89:
	yych = *++YYCURSOR;
	if (yych <= '@') goto yy78;
	if (yych <= 'Z') goto yy90;
	if (yych <= '`') goto yy78;
	if (yych >= '{') goto yy78;
yy90:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= ';') {
			if (yych <= 0x0000) goto yy78;
		} else {
			if (yych <= '<') goto yy78;
			if (yych >= '>') goto yy94;
		}
	} else {
		if (yych <= 'Z') {
			if (yych >= 'A') goto yy90;
		} else {
			if (yych <= '`') goto yy92;
			if (yych <= 'z') goto yy90;
		}
	}
yy92:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '<') {
		if (yych <= 0x0000) goto yy78;
		if (yych <= ';') goto yy92;
		goto yy78;
	} else {
		if (yych != '>') goto yy92;
	}
yy94:
	++YYCURSOR;
#line 275 "mwlib/_mwscan.re"
	{RET(t_html_tag);}
#line 748 "mwlib/_mwscan.cc"
yy96:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy78;
yy97:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych != '-') goto yy97;
	} else {
		if (yych == '=') goto yy97;
		if (yych <= '>') goto yy78;
		goto yy97;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych != '-') goto yy97;
	} else {
		if (yych == '=') goto yy97;
		if (yych <= '>') goto yy78;
		goto yy97;
	}
yy100:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy78;
		if (yych == '-') goto yy100;
		goto yy97;
	} else {
		if (yych <= '<') goto yy78;
		if (yych != '>') goto yy97;
	}
	++YYCURSOR;
#line 278 "mwlib/_mwscan.re"
	{RET(t_comment);}
#line 787 "mwlib/_mwscan.cc"
yy104:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '\'') goto yy104;
#line 273 "mwlib/_mwscan.re"
	{RET(t_singlequote);}
#line 794 "mwlib/_mwscan.cc"
yy107:
	++YYCURSOR;
#line 256 "mwlib/_mwscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 807 "mwlib/_mwscan.cc"
yy109:
	++YYCURSOR;
#line 266 "mwlib/_mwscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 817 "mwlib/_mwscan.cc"
yy111:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '\n') goto yy111;
#line 253 "mwlib/_mwscan.re"
	{newline(); RET(t_break);}
#line 824 "mwlib/_mwscan.cc"
yy114:
	++YYCURSOR;
	yych = *YYCURSOR;
yy115:
	if (yych == '\t') goto yy114;
	if (yych == ' ') goto yy114;
	goto yy64;
yy116:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy114;
		goto yy64;
	} else {
		if (yych <= ' ') goto yy114;
		if (yych == '=') goto yy116;
		goto yy64;
	}
yy118:
	++YYCURSOR;
#line 240 "mwlib/_mwscan.re"
	{RET(t_2box_close);}
#line 847 "mwlib/_mwscan.cc"
yy120:
	++YYCURSOR;
	yych = *YYCURSOR;
yy121:
	if (yych <= 'Z') {
		if (yych <= '/') goto yy57;
		if (yych <= '9') goto yy120;
		if (yych <= '@') goto yy57;
		goto yy120;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy57;
			goto yy120;
		} else {
			if (yych <= '`') goto yy57;
			if (yych <= 'z') goto yy120;
			goto yy57;
		}
	}
yy122:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'E':	goto yy126;
	case 'F':	goto yy125;
	case 'N':	goto yy124;
	case 'S':	goto yy127;
	case 'T':	goto yy123;
	default:	goto yy121;
	}
yy123:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy253;
	goto yy121;
yy124:
	yych = *++YYCURSOR;
	if (yych <= 'N') {
		if (yych == 'E') goto yy146;
		goto yy121;
	} else {
		if (yych <= 'O') goto yy147;
		if (yych == 'U') goto yy148;
		goto yy121;
	}
yy125:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy138;
	goto yy121;
yy126:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy135;
	goto yy121;
yy127:
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
yy133:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 'Z') {
		if (yych <= '/') goto yy134;
		if (yych <= '9') goto yy120;
		if (yych >= 'A') goto yy120;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy120;
		} else {
			if (yych <= '`') goto yy134;
			if (yych <= 'z') goto yy120;
		}
	}
yy134:
#line 237 "mwlib/_mwscan.re"
	{RET(t_magicword);}
#line 929 "mwlib/_mwscan.cc"
yy135:
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy138:
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy146:
	yych = *++YYCURSOR;
	if (yych == 'W') goto yy240;
	goto yy121;
yy147:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':	goto yy166;
	case 'E':	goto yy165;
	case 'G':	goto yy167;
	case 'N':	goto yy168;
	case 'T':	goto yy164;
	default:	goto yy121;
	}
yy148:
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'B') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'H') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'G') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy164:
	yych = *++YYCURSOR;
	if (yych <= 'H') {
		if (yych == 'C') goto yy219;
		goto yy121;
	} else {
		if (yych <= 'I') goto yy220;
		if (yych == 'O') goto yy221;
		goto yy121;
	}
yy165:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy208;
	goto yy121;
yy166:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy192;
	if (yych == 'O') goto yy193;
	goto yy121;
yy167:
	yych = *++YYCURSOR;
	if (yych == 'A') goto yy185;
	goto yy121;
yy168:
	yych = *++YYCURSOR;
	if (yych != 'U') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'B') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'H') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'G') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy185:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'Y') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy192:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy207;
	goto yy121;
yy193:
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy207:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy208:
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy219:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy239;
	goto yy121;
yy220:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy228;
	goto yy121;
yy221:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy223;
	if (yych == '_') goto yy224;
	goto yy121;
yy223:
	yych = *++YYCURSOR;
	if (yych == 'U') goto yy225;
	goto yy121;
yy224:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy225:
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy228:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy239:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy240:
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'K') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy253:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy133;
	goto yy121;
yy256:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy121;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy260;
	if (yych != 's') goto yy121;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy121;
yy260:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych != '!') goto yy78;
			} else {
				if (yych == '*') goto yy78;
				if (yych >= '<') goto yy78;
			}
		} else {
			if (yych <= 'Z') {
				if (yych == '>') goto yy78;
			} else {
				if (yych == '_') goto yy263;
				if (yych <= '`') goto yy78;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych != '~') goto yy78;
			} else {
				if (yych <= 0x00C4) goto yy263;
				if (yych != 0x00D6) goto yy78;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy263;
				if (yych != 0x00E4) goto yy78;
			} else {
				if (yych <= 0x00F6) goto yy263;
				if (yych != 0x00FC) goto yy78;
			}
		}
	}
yy263:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych == '!') goto yy263;
			} else {
				if (yych == '*') goto yy265;
				if (yych <= ';') goto yy263;
			}
		} else {
			if (yych <= 'Z') {
				if (yych != '>') goto yy263;
			} else {
				if (yych == '_') goto yy263;
				if (yych >= 'a') goto yy263;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych == '~') goto yy263;
			} else {
				if (yych <= 0x00C4) goto yy263;
				if (yych == 0x00D6) goto yy263;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy263;
				if (yych == 0x00E4) goto yy263;
			} else {
				if (yych <= 0x00F6) goto yy263;
				if (yych == 0x00FC) goto yy263;
			}
		}
	}
yy265:
#line 236 "mwlib/_mwscan.re"
	{RET(t_http_url);}
#line 1328 "mwlib/_mwscan.cc"
yy266:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy121;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy121;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy78;
			if (yych >= '%') goto yy78;
		} else {
			if (yych <= ':') goto yy271;
			if (yych != '=') goto yy78;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy271;
			if (yych != '_') goto yy78;
		} else {
			if (yych == '|') goto yy78;
			if (yych >= 0x007F) goto yy78;
		}
	}
yy271:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy273;
			if (yych <= '$') goto yy271;
		} else {
			if (yych <= ':') goto yy271;
			if (yych == '=') goto yy271;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy271;
			if (yych == '_') goto yy271;
		} else {
			if (yych == '|') goto yy273;
			if (yych <= '~') goto yy271;
		}
	}
yy273:
#line 234 "mwlib/_mwscan.re"
	{RET(t_http_url);}
#line 1380 "mwlib/_mwscan.cc"
yy274:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy121;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy121;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy121;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy78;
	goto yy281;
yy280:
	++YYCURSOR;
	yych = *YYCURSOR;
yy281:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy280;
			if (yych <= '"') goto yy78;
			goto yy280;
		} else {
			if (yych <= ')') goto yy78;
			if (yych == ',') goto yy78;
			goto yy280;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy280;
			if (yych <= '>') goto yy78;
			goto yy280;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy280;
			} else {
				if (yych <= ']') goto yy78;
				if (yych <= '~') goto yy280;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy78;
		} else {
			if (yych <= '/') goto yy78;
			if (yych >= ':') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy283;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '`') goto yy78;
			if (yych >= '{') goto yy78;
		}
	}
yy283:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy283;
		} else {
			if (yych <= '/') goto yy285;
			if (yych <= '9') goto yy283;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy283;
			if (yych >= '_') goto yy283;
		} else {
			if (yych <= '`') goto yy285;
			if (yych <= 'z') goto yy283;
		}
	}
yy285:
#line 232 "mwlib/_mwscan.re"
	{RET(t_http_url);}
#line 1464 "mwlib/_mwscan.cc"
yy286:
	++YYCURSOR;
#line 239 "mwlib/_mwscan.re"
	{RET(t_2box_open);}
#line 1469 "mwlib/_mwscan.cc"
yy288:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy311;
	goto yy78;
yy289:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy303;
	goto yy78;
yy290:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy78;
	goto yy298;
yy297:
	++YYCURSOR;
	yych = *YYCURSOR;
yy298:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy297;
			if (yych <= '"') goto yy78;
			goto yy297;
		} else {
			if (yych <= ')') goto yy78;
			if (yych == ',') goto yy78;
			goto yy297;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy297;
			if (yych <= '>') goto yy78;
			goto yy297;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy297;
			} else {
				if (yych <= ']') goto yy78;
				if (yych <= '~') goto yy297;
				goto yy78;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy78;
		} else {
			if (yych <= '/') goto yy78;
			if (yych >= ':') goto yy78;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy300;
			if (yych <= '^') goto yy78;
		} else {
			if (yych <= '`') goto yy78;
			if (yych >= '{') goto yy78;
		}
	}
yy300:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy300;
		} else {
			if (yych <= '/') goto yy302;
			if (yych <= '9') goto yy300;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy300;
			if (yych >= '_') goto yy300;
		} else {
			if (yych <= '`') goto yy302;
			if (yych <= 'z') goto yy300;
		}
	}
yy302:
#line 231 "mwlib/_mwscan.re"
	{RET(t_urllink);}
#line 1562 "mwlib/_mwscan.cc"
yy303:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy78;
			if (yych >= '%') goto yy78;
		} else {
			if (yych <= ':') goto yy308;
			if (yych != '=') goto yy78;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy308;
			if (yych != '_') goto yy78;
		} else {
			if (yych == '|') goto yy78;
			if (yych >= 0x007F) goto yy78;
		}
	}
yy308:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy310;
			if (yych <= '$') goto yy308;
		} else {
			if (yych <= ':') goto yy308;
			if (yych == '=') goto yy308;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy308;
			if (yych == '_') goto yy308;
		} else {
			if (yych == '|') goto yy310;
			if (yych <= '~') goto yy308;
		}
	}
yy310:
#line 233 "mwlib/_mwscan.re"
	{RET(t_urllink);}
#line 1613 "mwlib/_mwscan.cc"
yy311:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy78;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy78;
	yych = *++YYCURSOR;
	if (yych == ':') goto yy315;
	if (yych != 's') goto yy78;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy78;
yy315:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy78;
	yych = *++YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych != '!') goto yy78;
			} else {
				if (yych == '*') goto yy78;
				if (yych >= '<') goto yy78;
			}
		} else {
			if (yych <= 'Z') {
				if (yych == '>') goto yy78;
			} else {
				if (yych == '_') goto yy318;
				if (yych <= '`') goto yy78;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych != '~') goto yy78;
			} else {
				if (yych <= 0x00C4) goto yy318;
				if (yych != 0x00D6) goto yy78;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy318;
				if (yych != 0x00E4) goto yy78;
			} else {
				if (yych <= 0x00F6) goto yy318;
				if (yych != 0x00FC) goto yy78;
			}
		}
	}
yy318:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych == '!') goto yy318;
			} else {
				if (yych == '*') goto yy320;
				if (yych <= ';') goto yy318;
			}
		} else {
			if (yych <= 'Z') {
				if (yych != '>') goto yy318;
			} else {
				if (yych == '_') goto yy318;
				if (yych >= 'a') goto yy318;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych == '~') goto yy318;
			} else {
				if (yych <= 0x00C4) goto yy318;
				if (yych == 0x00D6) goto yy318;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy318;
				if (yych == 0x00E4) goto yy318;
			} else {
				if (yych <= 0x00F6) goto yy318;
				if (yych == 0x00FC) goto yy318;
			}
		}
	}
yy320:
#line 235 "mwlib/_mwscan.re"
	{RET(t_urllink);}
#line 1704 "mwlib/_mwscan.cc"
}
#line 283 "mwlib/_mwscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_mwscan();
}

DL_EXPORT(void) init_mwscan()
{
	/*PyObject *m =*/ Py_InitModule("_mwscan", module_functions);
}
