/* Generated by re2c 0.13.5 */
#line 1 "mwlib/_uscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2009 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_singlequote,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() {
		if ((start==source) || (start[-1]=='\n')) {
			memset(&lineflags, 0, sizeof(lineflags));
			return true;
		} else {
			return false;
		}
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
	struct {
		int rowchar;
	} lineflags;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 132 "mwlib/_uscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 168 "mwlib/_uscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 148 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if (yych <= '-') {
		if (yych <= '"') {
			if (yych <= 0x001F) goto yy15;
			if (yych <= ' ') goto yy2;
			if (yych <= '!') goto yy10;
			goto yy15;
		} else {
			if (yych <= ')') {
				if (yych <= '#') goto yy13;
				goto yy15;
			} else {
				if (yych <= '*') goto yy13;
				if (yych <= ',') goto yy15;
				goto yy14;
			}
		}
	} else {
		if (yych <= '<') {
			if (yych <= '9') goto yy15;
			if (yych <= ':') goto yy4;
			if (yych <= ';') goto yy13;
			goto yy15;
		} else {
			if (yych <= 'z') {
				if (yych <= '=') goto yy11;
				goto yy15;
			} else {
				if (yych <= '{') goto yy6;
				if (yych <= '|') goto yy8;
				goto yy15;
			}
		}
	}
yy2:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy3;
		if (yych <= '!') goto yy43;
	} else {
		if (yych <= ':') goto yy43;
		if (yych <= 'z') goto yy3;
		if (yych <= '|') goto yy43;
	}
yy3:
#line 212 "mwlib/_uscan.re"
	{RET(t_pre);}
#line 201 "mwlib/_uscan.cc"
yy4:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy38;
	if (yych == '{') goto yy40;
	goto yy23;
yy5:
#line 217 "mwlib/_uscan.re"
	{RET(t_item);}
#line 211 "mwlib/_uscan.cc"
yy6:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '|') goto yy36;
yy7:
#line 220 "mwlib/_uscan.re"
	{goto not_bol;}
#line 218 "mwlib/_uscan.cc"
yy8:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ',') {
		if (yych == '+') goto yy28;
	} else {
		if (yych <= '-') goto yy31;
		if (yych == '}') goto yy34;
	}
yy9:
#line 188 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        lineflags.rowchar=cursor[-1];
			RET(t_column);
		}

		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 241 "mwlib/_uscan.cc"
yy10:
	yych = *++YYCURSOR;
	goto yy9;
yy11:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy26;
	goto yy25;
yy12:
#line 213 "mwlib/_uscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 255 "mwlib/_uscan.cc"
yy13:
	yych = *++YYCURSOR;
	goto yy23;
yy14:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '-') goto yy16;
	goto yy7;
yy15:
	yych = *++YYCURSOR;
	goto yy7;
yy16:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy18;
yy17:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy5;
		}
	} else {
		goto yy7;
	}
yy18:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy17;
yy19:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy19;
#line 218 "mwlib/_uscan.re"
	{RET(t_hrule);}
#line 290 "mwlib/_uscan.cc"
yy22:
	++YYCURSOR;
	yych = *YYCURSOR;
yy23:
	if (yych <= ')') {
		if (yych == '#') goto yy22;
		goto yy5;
	} else {
		if (yych <= '*') goto yy22;
		if (yych <= '9') goto yy5;
		if (yych <= ';') goto yy22;
		goto yy5;
	}
yy24:
	++YYCURSOR;
	yych = *YYCURSOR;
yy25:
	if (yych == '\t') goto yy24;
	if (yych == ' ') goto yy24;
	goto yy12;
yy26:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy24;
		goto yy12;
	} else {
		if (yych <= ' ') goto yy24;
		if (yych == '=') goto yy26;
		goto yy12;
	}
yy28:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '+') goto yy28;
#line 202 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 336 "mwlib/_uscan.cc"
yy31:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy31;
#line 177 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_row);
		if (*start==' ') {
			cursor = start+1;
			RET(t_pre);
		}
		RET(t_text);
	}
#line 351 "mwlib/_uscan.cc"
yy34:
	++YYCURSOR;
#line 174 "mwlib/_uscan.re"
	{--tablemode; RET(t_end_table);}
#line 356 "mwlib/_uscan.cc"
yy36:
	++YYCURSOR;
#line 173 "mwlib/_uscan.re"
	{++tablemode; RET(t_begin_table);}
#line 361 "mwlib/_uscan.cc"
yy38:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '9') {
		if (yych <= '#') {
			if (yych <= '"') goto yy5;
			goto yy22;
		} else {
			if (yych == '*') goto yy22;
			goto yy5;
		}
	} else {
		if (yych <= ';') {
			if (yych <= ':') goto yy38;
			goto yy22;
		} else {
			if (yych != '{') goto yy5;
		}
	}
yy40:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy36;
	goto yy17;
yy41:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy28;
		goto yy9;
	} else {
		if (yych <= '-') goto yy31;
		if (yych == '}') goto yy34;
		goto yy9;
	}
yy42:
	++YYCURSOR;
	yych = *YYCURSOR;
yy43:
	if (yych <= '9') {
		if (yych <= 0x001F) goto yy17;
		if (yych <= ' ') goto yy42;
		if (yych >= '"') goto yy17;
	} else {
		if (yych <= 'z') {
			if (yych <= ':') goto yy45;
			goto yy17;
		} else {
			if (yych <= '{') goto yy40;
			if (yych <= '|') goto yy41;
			goto yy17;
		}
	}
	yych = *++YYCURSOR;
	goto yy9;
yy45:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == ':') goto yy45;
	if (yych == '{') goto yy40;
	goto yy17;
}
#line 221 "mwlib/_uscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 432 "mwlib/_uscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\'') {
			if (yych <= ' ') {
				if (yych <= 0x0000) goto yy69;
				if (yych == '\n') goto yy60;
				goto yy71;
			} else {
				if (yych <= '!') goto yy63;
				if (yych <= '%') goto yy71;
				if (yych <= '&') goto yy68;
				goto yy66;
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') goto yy71;
				if (yych <= '9') goto yy56;
				if (yych <= ':') goto yy65;
				goto yy71;
			} else {
				if (yych <= '<') goto yy67;
				if (yych <= '=') goto yy58;
				if (yych <= '@') goto yy71;
				goto yy56;
			}
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '^') {
				if (yych <= '[') goto yy49;
				if (yych == ']') goto yy57;
				goto yy71;
			} else {
				if (yych <= '_') goto yy55;
				if (yych <= '`') goto yy71;
				if (yych <= 'e') goto yy56;
				goto yy53;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'h') goto yy54;
				if (yych <= 'l') goto yy56;
				goto yy51;
			} else {
				if (yych <= 'z') goto yy56;
				if (yych == '|') goto yy62;
				goto yy71;
			}
		}
	}
yy49:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '[':	goto yy281;
	case 'f':	goto yy284;
	case 'h':	goto yy283;
	case 'm':	goto yy285;
	default:	goto yy50;
	}
yy50:
#line 270 "mwlib/_uscan.re"
	{RET(t_special);}
#line 499 "mwlib/_uscan.cc"
yy51:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 'a') goto yy269;
	goto yy116;
yy52:
#line 236 "mwlib/_uscan.re"
	{RET(t_text);}
#line 507 "mwlib/_uscan.cc"
yy53:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy261;
	goto yy116;
yy54:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy251;
	goto yy116;
yy55:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy117;
	goto yy116;
yy56:
	yych = *++YYCURSOR;
	goto yy116;
yy57:
	yych = *++YYCURSOR;
	if (yych == ']') goto yy113;
	goto yy50;
yy58:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy111;
	goto yy110;
yy59:
#line 239 "mwlib/_uscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 545 "mwlib/_uscan.cc"
yy60:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\n') goto yy106;
#line 252 "mwlib/_uscan.re"
	{newline(); RET(t_newline);}
#line 551 "mwlib/_uscan.cc"
yy62:
	yych = *++YYCURSOR;
	if (yych <= '*') {
		if (yych == '!') goto yy102;
		goto yy50;
	} else {
		if (yych <= '+') goto yy104;
		if (yych == '|') goto yy102;
		goto yy50;
	}
yy63:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '!') goto yy102;
yy64:
#line 280 "mwlib/_uscan.re"
	{RET(t_text);}
#line 568 "mwlib/_uscan.cc"
yy65:
	yych = *++YYCURSOR;
	goto yy50;
yy66:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy99;
	goto yy64;
yy67:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych == '!') goto yy83;
		if (yych <= '.') goto yy64;
		goto yy84;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy64;
			goto yy85;
		} else {
			if (yych <= '`') goto yy64;
			if (yych <= 'z') goto yy85;
			goto yy64;
		}
	}
yy68:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych == '#') goto yy72;
		if (yych <= '/') goto yy64;
		goto yy74;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy64;
			goto yy74;
		} else {
			if (yych <= '`') goto yy64;
			if (yych <= 'z') goto yy74;
			goto yy64;
		}
	}
yy69:
	++YYCURSOR;
#line 279 "mwlib/_uscan.re"
	{newline(); return t_end;}
#line 614 "mwlib/_uscan.cc"
yy71:
	yych = *++YYCURSOR;
	goto yy64;
yy72:
	yych = *++YYCURSOR;
	if (yych <= 'W') {
		if (yych <= '/') goto yy73;
		if (yych <= '9') goto yy79;
	} else {
		if (yych <= 'X') goto yy78;
		if (yych == 'x') goto yy78;
	}
yy73:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy50;
		} else {
			goto yy64;
		}
	} else {
		goto yy52;
	}
yy74:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy73;
		if (yych <= '9') goto yy74;
		if (yych <= ':') goto yy73;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy73;
			goto yy74;
		} else {
			if (yych <= '`') goto yy73;
			if (yych <= 'z') goto yy74;
			goto yy73;
		}
	}
yy76:
	++YYCURSOR;
#line 277 "mwlib/_uscan.re"
	{RET(t_entity);}
#line 659 "mwlib/_uscan.cc"
yy78:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy73;
	goto yy82;
yy79:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '/') goto yy73;
	if (yych <= '9') goto yy79;
	if (yych == ';') goto yy76;
	goto yy73;
yy81:
	++YYCURSOR;
	yych = *YYCURSOR;
yy82:
	if (yych <= ';') {
		if (yych <= '/') goto yy73;
		if (yych <= '9') goto yy81;
		if (yych <= ':') goto yy73;
		goto yy76;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy73;
			goto yy81;
		} else {
			if (yych <= '`') goto yy73;
			if (yych <= 'f') goto yy81;
			goto yy73;
		}
	}
yy83:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy91;
	goto yy73;
yy84:
	yych = *++YYCURSOR;
	if (yych <= '@') goto yy73;
	if (yych <= 'Z') goto yy85;
	if (yych <= '`') goto yy73;
	if (yych >= '{') goto yy73;
yy85:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= ';') {
			if (yych <= 0x0000) goto yy73;
		} else {
			if (yych <= '<') goto yy73;
			if (yych >= '>') goto yy89;
		}
	} else {
		if (yych <= 'Z') {
			if (yych >= 'A') goto yy85;
		} else {
			if (yych <= '`') goto yy87;
			if (yych <= 'z') goto yy85;
		}
	}
yy87:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '<') {
		if (yych <= 0x0000) goto yy73;
		if (yych <= ';') goto yy87;
		goto yy73;
	} else {
		if (yych != '>') goto yy87;
	}
yy89:
	++YYCURSOR;
#line 273 "mwlib/_uscan.re"
	{RET(t_html_tag);}
#line 732 "mwlib/_uscan.cc"
yy91:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy73;
yy92:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy73;
		if (yych != '-') goto yy92;
	} else {
		if (yych == '=') goto yy92;
		if (yych <= '>') goto yy73;
		goto yy92;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy73;
		if (yych != '-') goto yy92;
	} else {
		if (yych == '=') goto yy92;
		if (yych <= '>') goto yy73;
		goto yy92;
	}
yy95:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy73;
		if (yych == '-') goto yy95;
		goto yy92;
	} else {
		if (yych <= '<') goto yy73;
		if (yych != '>') goto yy92;
	}
	++YYCURSOR;
#line 276 "mwlib/_uscan.re"
	{RET(t_comment);}
#line 771 "mwlib/_uscan.cc"
yy99:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '\'') goto yy99;
#line 271 "mwlib/_uscan.re"
	{RET(t_singlequote);}
#line 778 "mwlib/_uscan.cc"
yy102:
	++YYCURSOR;
#line 254 "mwlib/_uscan.re"
	{
		if (tablemode) {
		        if (cursor[-2]!='!' || cursor[-2]==lineflags.rowchar) {
			       RET(t_column);
			}
		}
		cursor = start+1;
		RET(t_special);
	}
#line 791 "mwlib/_uscan.cc"
yy104:
	++YYCURSOR;
#line 264 "mwlib/_uscan.re"
	{
		if (tablemode) 
			RET(t_tablecaption);
		cursor = start+1;
		RET(t_special);
	}
#line 801 "mwlib/_uscan.cc"
yy106:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '\n') goto yy106;
#line 251 "mwlib/_uscan.re"
	{newline(); RET(t_break);}
#line 808 "mwlib/_uscan.cc"
yy109:
	++YYCURSOR;
	yych = *YYCURSOR;
yy110:
	if (yych == '\t') goto yy109;
	if (yych == ' ') goto yy109;
	goto yy59;
yy111:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == '\t') goto yy109;
		goto yy59;
	} else {
		if (yych <= ' ') goto yy109;
		if (yych == '=') goto yy111;
		goto yy59;
	}
yy113:
	++YYCURSOR;
#line 238 "mwlib/_uscan.re"
	{RET(t_2box_close);}
#line 831 "mwlib/_uscan.cc"
yy115:
	++YYCURSOR;
	yych = *YYCURSOR;
yy116:
	if (yych <= 'Z') {
		if (yych <= '/') goto yy52;
		if (yych <= '9') goto yy115;
		if (yych <= '@') goto yy52;
		goto yy115;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy52;
			goto yy115;
		} else {
			if (yych <= '`') goto yy52;
			if (yych <= 'z') goto yy115;
			goto yy52;
		}
	}
yy117:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'E':	goto yy121;
	case 'F':	goto yy120;
	case 'N':	goto yy119;
	case 'S':	goto yy122;
	case 'T':	goto yy118;
	default:	goto yy116;
	}
yy118:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy248;
	goto yy116;
yy119:
	yych = *++YYCURSOR;
	if (yych <= 'N') {
		if (yych == 'E') goto yy141;
		goto yy116;
	} else {
		if (yych <= 'O') goto yy142;
		if (yych == 'U') goto yy143;
		goto yy116;
	}
yy120:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy133;
	goto yy116;
yy121:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy130;
	goto yy116;
yy122:
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
yy128:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 'Z') {
		if (yych <= '/') goto yy129;
		if (yych <= '9') goto yy115;
		if (yych >= 'A') goto yy115;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy115;
		} else {
			if (yych <= '`') goto yy129;
			if (yych <= 'z') goto yy115;
		}
	}
yy129:
#line 235 "mwlib/_uscan.re"
	{RET(t_magicword);}
#line 913 "mwlib/_uscan.cc"
yy130:
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy133:
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy141:
	yych = *++YYCURSOR;
	if (yych == 'W') goto yy235;
	goto yy116;
yy142:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':	goto yy161;
	case 'E':	goto yy160;
	case 'G':	goto yy162;
	case 'N':	goto yy163;
	case 'T':	goto yy159;
	default:	goto yy116;
	}
yy143:
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'B') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'H') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'G') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy159:
	yych = *++YYCURSOR;
	if (yych <= 'H') {
		if (yych == 'C') goto yy214;
		goto yy116;
	} else {
		if (yych <= 'I') goto yy215;
		if (yych == 'O') goto yy216;
		goto yy116;
	}
yy160:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy203;
	goto yy116;
yy161:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy187;
	if (yych == 'O') goto yy188;
	goto yy116;
yy162:
	yych = *++YYCURSOR;
	if (yych == 'A') goto yy180;
	goto yy116;
yy163:
	yych = *++YYCURSOR;
	if (yych != 'U') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'B') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'H') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'G') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy180:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'Y') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy187:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy202;
	goto yy116;
yy188:
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy202:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy203:
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy214:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy234;
	goto yy116;
yy215:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy223;
	goto yy116;
yy216:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy218;
	if (yych == '_') goto yy219;
	goto yy116;
yy218:
	yych = *++YYCURSOR;
	if (yych == 'U') goto yy220;
	goto yy116;
yy219:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy220:
	yych = *++YYCURSOR;
	if (yych != 'M') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy223:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy234:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy235:
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'K') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy248:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy128;
	goto yy116;
yy251:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy116;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy255;
	if (yych != 's') goto yy116;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy116;
yy255:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych != '!') goto yy73;
			} else {
				if (yych == '*') goto yy73;
				if (yych >= '<') goto yy73;
			}
		} else {
			if (yych <= 'Z') {
				if (yych == '>') goto yy73;
			} else {
				if (yych == '_') goto yy258;
				if (yych <= '`') goto yy73;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych != '~') goto yy73;
			} else {
				if (yych <= 0x00C4) goto yy258;
				if (yych != 0x00D6) goto yy73;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy258;
				if (yych != 0x00E4) goto yy73;
			} else {
				if (yych <= 0x00F6) goto yy258;
				if (yych != 0x00FC) goto yy73;
			}
		}
	}
yy258:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych == '!') goto yy258;
			} else {
				if (yych == '*') goto yy260;
				if (yych <= ';') goto yy258;
			}
		} else {
			if (yych <= 'Z') {
				if (yych != '>') goto yy258;
			} else {
				if (yych == '_') goto yy258;
				if (yych >= 'a') goto yy258;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych == '~') goto yy258;
			} else {
				if (yych <= 0x00C4) goto yy258;
				if (yych == 0x00D6) goto yy258;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy258;
				if (yych == 0x00E4) goto yy258;
			} else {
				if (yych <= 0x00F6) goto yy258;
				if (yych == 0x00FC) goto yy258;
			}
		}
	}
yy260:
#line 234 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1312 "mwlib/_uscan.cc"
yy261:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy116;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy116;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy73;
			if (yych >= '%') goto yy73;
		} else {
			if (yych <= ':') goto yy266;
			if (yych != '=') goto yy73;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy266;
			if (yych != '_') goto yy73;
		} else {
			if (yych == '|') goto yy73;
			if (yych >= 0x007F) goto yy73;
		}
	}
yy266:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy268;
			if (yych <= '$') goto yy266;
		} else {
			if (yych <= ':') goto yy266;
			if (yych == '=') goto yy266;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy266;
			if (yych == '_') goto yy266;
		} else {
			if (yych == '|') goto yy268;
			if (yych <= '~') goto yy266;
		}
	}
yy268:
#line 232 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1364 "mwlib/_uscan.cc"
yy269:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy116;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy116;
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy116;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy73;
	goto yy276;
yy275:
	++YYCURSOR;
	yych = *YYCURSOR;
yy276:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy275;
			if (yych <= '"') goto yy73;
			goto yy275;
		} else {
			if (yych <= ')') goto yy73;
			if (yych == ',') goto yy73;
			goto yy275;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy275;
			if (yych <= '>') goto yy73;
			goto yy275;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy275;
			} else {
				if (yych <= ']') goto yy73;
				if (yych <= '~') goto yy275;
				goto yy73;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy73;
		} else {
			if (yych <= '/') goto yy73;
			if (yych >= ':') goto yy73;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy278;
			if (yych <= '^') goto yy73;
		} else {
			if (yych <= '`') goto yy73;
			if (yych >= '{') goto yy73;
		}
	}
yy278:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy278;
		} else {
			if (yych <= '/') goto yy280;
			if (yych <= '9') goto yy278;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy278;
			if (yych >= '_') goto yy278;
		} else {
			if (yych <= '`') goto yy280;
			if (yych <= 'z') goto yy278;
		}
	}
yy280:
#line 230 "mwlib/_uscan.re"
	{RET(t_http_url);}
#line 1448 "mwlib/_uscan.cc"
yy281:
	++YYCURSOR;
#line 237 "mwlib/_uscan.re"
	{RET(t_2box_open);}
#line 1453 "mwlib/_uscan.cc"
yy283:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy306;
	goto yy73;
yy284:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy298;
	goto yy73;
yy285:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy73;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy73;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy73;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy73;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy73;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy73;
	yych = *++YYCURSOR;
	if (yych == '@') goto yy73;
	goto yy293;
yy292:
	++YYCURSOR;
	yych = *YYCURSOR;
yy293:
	if (yych <= '9') {
		if (yych <= '\'') {
			if (yych == '!') goto yy292;
			if (yych <= '"') goto yy73;
			goto yy292;
		} else {
			if (yych <= ')') goto yy73;
			if (yych == ',') goto yy73;
			goto yy292;
		}
	} else {
		if (yych <= '?') {
			if (yych == '=') goto yy292;
			if (yych <= '>') goto yy73;
			goto yy292;
		} else {
			if (yych <= 'Z') {
				if (yych >= 'A') goto yy292;
			} else {
				if (yych <= ']') goto yy73;
				if (yych <= '~') goto yy292;
				goto yy73;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych <= ',') goto yy73;
		} else {
			if (yych <= '/') goto yy73;
			if (yych >= ':') goto yy73;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy295;
			if (yych <= '^') goto yy73;
		} else {
			if (yych <= '`') goto yy73;
			if (yych >= '{') goto yy73;
		}
	}
yy295:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '.') {
			if (yych >= '-') goto yy295;
		} else {
			if (yych <= '/') goto yy297;
			if (yych <= '9') goto yy295;
		}
	} else {
		if (yych <= '_') {
			if (yych <= 'Z') goto yy295;
			if (yych >= '_') goto yy295;
		} else {
			if (yych <= '`') goto yy297;
			if (yych <= 'z') goto yy295;
		}
	}
yy297:
#line 229 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1546 "mwlib/_uscan.cc"
yy298:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy73;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy73;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy73;
			if (yych >= '%') goto yy73;
		} else {
			if (yych <= ':') goto yy303;
			if (yych != '=') goto yy73;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy303;
			if (yych != '_') goto yy73;
		} else {
			if (yych == '|') goto yy73;
			if (yych >= 0x007F) goto yy73;
		}
	}
yy303:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= '%') {
			if (yych <= '"') goto yy305;
			if (yych <= '$') goto yy303;
		} else {
			if (yych <= ':') goto yy303;
			if (yych == '=') goto yy303;
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'Z') goto yy303;
			if (yych == '_') goto yy303;
		} else {
			if (yych == '|') goto yy305;
			if (yych <= '~') goto yy303;
		}
	}
yy305:
#line 231 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1597 "mwlib/_uscan.cc"
yy306:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy73;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy73;
	yych = *++YYCURSOR;
	if (yych == ':') goto yy310;
	if (yych != 's') goto yy73;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy73;
yy310:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy73;
	yych = *++YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych != '!') goto yy73;
			} else {
				if (yych == '*') goto yy73;
				if (yych >= '<') goto yy73;
			}
		} else {
			if (yych <= 'Z') {
				if (yych == '>') goto yy73;
			} else {
				if (yych == '_') goto yy313;
				if (yych <= '`') goto yy73;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych != '~') goto yy73;
			} else {
				if (yych <= 0x00C4) goto yy313;
				if (yych != 0x00D6) goto yy73;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy313;
				if (yych != 0x00E4) goto yy73;
			} else {
				if (yych <= 0x00F6) goto yy313;
				if (yych != 0x00FC) goto yy73;
			}
		}
	}
yy313:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '<') {
			if (yych <= '"') {
				if (yych == '!') goto yy313;
			} else {
				if (yych == '*') goto yy315;
				if (yych <= ';') goto yy313;
			}
		} else {
			if (yych <= 'Z') {
				if (yych != '>') goto yy313;
			} else {
				if (yych == '_') goto yy313;
				if (yych >= 'a') goto yy313;
			}
		}
	} else {
		if (yych <= 0x00DB) {
			if (yych <= 0x00C3) {
				if (yych == '~') goto yy313;
			} else {
				if (yych <= 0x00C4) goto yy313;
				if (yych == 0x00D6) goto yy313;
			}
		} else {
			if (yych <= 0x00F5) {
				if (yych <= 0x00DC) goto yy313;
				if (yych == 0x00E4) goto yy313;
			} else {
				if (yych <= 0x00F6) goto yy313;
				if (yych == 0x00FC) goto yy313;
			}
		}
	}
yy315:
#line 233 "mwlib/_uscan.re"
	{RET(t_urllink);}
#line 1688 "mwlib/_uscan.cc"
}
#line 281 "mwlib/_uscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" {
	DL_EXPORT(void) init_uscan();
}

DL_EXPORT(void) init_uscan()
{
	/*PyObject *m =*/ Py_InitModule("_uscan", module_functions);
}
